/*
Playlister is developed by Will Woodgate (@willwoodgate or willwoodgate.com)
*/

$(document).ready(function() {
	// Variables
	var playlist = $('#playlisterPlaylist%id%');
	%[if %("%id=check_for_item_visibility%" == "true")% ]%
	var playlistitem = $('#playlisterPlaylist%id% li:visible');
	%[endif]%
	%[if %("%id=check_for_item_visibility%" == "false")% ]%
	var playlistitem = $('#playlisterPlaylist%id% li');
	%[endif]%
	var audiohref = $(playlistitem).eq(0).data("audiohref");
	var audio = $("#myaudioplayer%id%");
	var audioduration = $(audio.currentTime);
	var tracktitle = $(playlistitem).eq(0).data("tracktitle");
	var cover = $(playlistitem).eq(0).data("artworkhref");
	var artist = $(playlistitem).eq(0).data("artist");
	var album = $(playlistitem).eq(0).data("album");
	var additionalinfo = $(playlistitem).eq(0).data("additionalinfo");

	// Look for iOS devices
	if (navigator.userAgent.match(/(iPod|iPhone|iPad)/)) {
		$('body').addClass('playlister_ios_device');
	} else {
		$('body').addClass('playlister_not_ios_device');
	}

	%[if %("%id=track_numbers%" == "true")% ]%
	// Display a number next to each item in the playlist
	$("#playlisterPlaylist%id% li span.playlistItemNumber").each(function(index) {
	  $(this).text(1+index);
	});
	%[endif]%

	%[if %("%id=reverse_playlistitems%" == "true")% ]%
	var listItems = playlist.children('li');
	playlist.append(listItems.get().reverse());
	%[endif]%

	// Construct a new HTML5 audio player as the page loads and populate it with our first audio track and associated data
	$("#playlisterPlaceholder%id%").html('<audio id="myaudioplayer%id%" controls="controls" playsinline autobuffer preload="%id=preloading%" src="'+audiohref+'"' +' %id=autoplay_enable%></audio>');
	$("#download%id%").html('<a class="download playlisterButtonStandard" download href="'+audiohref+'"' +'>%id=download_label%</a>');
	$("#playlisterPlaylist%id% li:visible").eq(0).addClass("active-playlistitem");
	$('#playlister%id% #cover%id%').css('background-image','url(' + cover+')');
	$('#playlister%id% #title%id%').text(tracktitle);
	$('#playlister%id% #artist%id%').text(artist);
	$('#playlister%id% #album%id%').text(album);
	$('#playlister%id% #additionalInfo%id%').html(additionalinfo);
	$('#playlister%id% #duration%id%').text(audioduration);
	$('#playlister%id% #inline_download_%id%').attr("href", audiohref);
	progressBar();

	// Remove any existing custom buttons and append new custom buttons in the additional information boxes to the top right
	$("#userOptionsBar%id% .playlisterInterfaceComponent").remove();
	$("#additionalInfo%id% a.playlisterButton").appendTo('#userOptionsBar%id%').wrap('<div class="playlisterInterfaceComponent"></div>');

	%[if %("%id=sequentialplay_enable%" == "true")% ]%
	// Play next item in the playlist
	$('.playlister_not_ios_device #myaudioplayer%id%').on('ended',function(){
		var next = $('#playlisterPlaylist%id% li.active-playlistitem').next();
		$(next).trigger("click");
		progressBar();
	});

	$('.playlister_ios_device #myaudioplayer%id%').on('ended',function(){
		audio.currentTime = 0;
		$("#myaudioplayer%id%")[0].pause();
		$('#playlister%id%').removeClass('playlisterIsPlaying');
		$('#progress%id%').width(0);
		$('#current%id%').text('00:00');
	});
	%[endif]%

	%[if %("%id=autoplay_enable%" == "autoplay")% ]%
	// If autoplay is enabled
	$('#playlister%id%').addClass('playlisterIsPlaying');
	%[endif]%

	// Ending functionality
	$('.playlister_not_ios_device #myaudioplayer%id%').on('ended',function(){
		audio.currentTime = 0;
		$('#playlister%id%').removeClass('playlisterIsPlaying');
			%[if %("%id=sequentialplay_enable%" == "true")% ]%
			$('#playlister%id%').addClass('playlisterIsPlaying');
			%[endif]%
		$('#progress%id%').width(0);
		$('#current%id%').text('00:00');
	});

	// When a playlist item is clicked (physically or virtually by a button), rebuild the audio player to include our new audio track and start playing it
	$("#playlisterPlaylist%id% li").on("click", function() {
		$("#playlisterPlaylist%id% li").removeClass('active-playlistitem');
		$(this).addClass('active-playlistitem');

		var audiohref = $(this).data("audiohref");
		var cover = $(this).data("artworkhref");
		var tracktitle = $(this).data("tracktitle");
		var artist = $(this).data("artist");
		var album = $(this).data("album");
		var additionalinfo = $(this).data("additionalinfo");

		$("#playlisterPlaceholder%id%").html('<audio id="myaudioplayer%id%" controls="controls" playsinline autobuffer preload="%id=preloading%" src="'+audiohref+'"' +'></audio>');
		$("#download%id%").html('<a class="download playlisterButtonStandard" download href="'+audiohref+'"' +'>%id=download_label%</a>');
		$("#myaudioplayer%id%")[0].play();
		$('#playlister%id% #inline_download_%id%').attr("href", audiohref);
		progressBar();

		$('#playlister%id% #cover%id%').css('background-image','url(' + cover+')');
		$('#playlister%id% #title%id%').text(tracktitle);
		$('#playlister%id% #artist%id%').text(artist);
		$('#playlister%id% #album%id%').text(album);
		$('#playlister%id% #additionalInfo%id%').html(additionalinfo);
		$('#playlister%id%').removeClass('playlisterIsPlaying');
		$('#playlister%id%').addClass('playlisterIsPlaying');

		// Remove any existing custom buttons and append new custom buttons in the additional information boxes to the top right
		$("#userOptionsBar%id% .playlisterInterfaceComponent").remove();
		$("#additionalInfo%id% a.playlisterButton").appendTo('#userOptionsBar%id%').wrap('<div class="playlisterInterfaceComponent"></div>');

		%[if %("%id=sequentialplay_enable%" == "true")% ]%
		// Play next item in the playlist
		$('.playlister_not_ios_device #myaudioplayer%id%').on('ended',function(){
			var next = $('#playlisterPlaylist%id% li:visible.active-playlistitem').next();
			$(next).trigger("click");
			progressBar();
		});

		$('.playlister_ios_device #myaudioplayer%id%').on('ended',function(){
			audio.currentTime = 0;
			$("#myaudioplayer%id%")[0].pause();
			$('#playlister%id%').removeClass('playlisterIsPlaying');
			$('#progress%id%').width(0);
			$('#current%id%').text('00:00');
		});
		%[endif]%
	})

	// Play button
	$('#play%id%').click(function() {
		$("#myaudioplayer%id%")[0].play();
		$('#playlister%id%').addClass('playlisterIsPlaying');
		progressBar();
	});

	// Pause button
	$('#pause%id%').click(function() {
		$("#myaudioplayer%id%")[0].pause();
		$('#playlister%id%').removeClass('playlisterIsPlaying');
	});

	// Replay button
	$('#repeat%id%').click(function() {
		$("#myaudioplayer%id%")[0].currentTime = 0;
		$("#myaudioplayer%id%")[0].play();
		progressBar();

	});

	// Backwards button
	$('#rewind%id%').click(function() {
		$("#myaudioplayer%id%")[0].pause();
		var prev = $('#playlisterPlaylist%id% li:visible.active-playlistitem').prev();
		$(prev).trigger("click");
		progressBar();

	});

	// Forward button
	$('#fastforward%id%').click(function() {
		$("#myaudioplayer%id%")[0].pause();
		var next = $('#playlisterPlaylist%id% li:visible.active-playlistitem').next();
		$(next).trigger("click");
		progressBar();

	});

	// Volume button
	$('#volumeBtn%id%').click(function() {
		$("#volumeControls%id%").slideToggle(300);
	});

	// Volume slider
	var volume = $('#volume%id%');
	$("#myaudioplayer%id%")[0].volume = 0.%id=default_volume%;

	volume.slider({
		range: 'min',
		min: 1,
		max: 100,
		value: %id=default_volume%,
		orientation: "vertical",
		start: function(event,ui) {},
		slide: function(event, ui) {
			$("#myaudioplayer%id%")[0].volume = ui.value / 100;
		},
		stop: function(event,ui) {},
	});

	// Scrubber functionality
	function progressBar() {
		var $video = $("#myaudioplayer%id%");
		var $scrubber = $("#tracker%id%");
		var $progress = $("#progress%id%");

		$video.bind("timeupdate", videoTimeUpdateHandler);
		$scrubber.bind("mousedown", scrubberMouseDownHandler);

		function videoTimeUpdateHandler(e) {
			var video = $video.get(0);
			var percent = video.currentTime / video.duration;
			updateProgressWidth(percent);
		}

		function scrubberMouseDownHandler(e) {
			var $this = $(this);
			var x = e.pageX - $this.offset().left;
			var percent = x / $this.width();
			updateProgressWidth(percent);
			updateVideoTime(percent);
		}

		function updateProgressWidth(percent) {
			$progress.width((percent * 100) + "%");
		}

		function updateVideoTime(percent) {
			var video = $video.get(0);
			video.currentTime = percent * video.duration;
		}

		// Timer functionality
		var theTimer = $('#current%id%');
		var mymedia = $("#myaudioplayer%id%").get(0);

		mymedia.addEventListener("timeupdate", runTimer, false);

		function runTimer() {
			var currentTime = mymedia.currentTime;
			var mTime = Math.floor(mymedia.currentTime/60);
			var sTime = Math.floor(mymedia.currentTime-(mTime*60));
			if (sTime<10) {sTime="0"+sTime;}
			if (mTime<10) {mTime="0"+mTime;}
			theTimer.text(mTime+":"+sTime);
		};

		// Total Time Functionality
		var totalTimeDiv = $('#duration%id%');

		mymedia.addEventListener("canplay", function() {
			var totalTime = mymedia.duration;
			var mTime = Math.floor(totalTime/60);
			var sTime = Math.floor(totalTime-(mTime*60));
			if (sTime<10) {sTime="0"+sTime;}
			if (mTime<10) {mTime="0"+mTime;}
			totalTimeDiv.text(mTime+":"+sTime);

		}, false );

	}

	// Playlist toggle button
	$('#playlistToggle%id%').click(function() {
		$("#playlisterPlaylist%id%").toggleClass('playListClosed');
	});

	%[if %("%id=append_player%" == "true")% ]%
	// Append player to another container in the page
	$("#playlister%id%").appendTo('%id=append_id%');
	%[endif]%

});

// Only show the duration time when the audio is loaded
$(window).on("load", function (e) {
	var audio = $("#myaudioplayer%id%").get(0);
	window.setInterval(function(){
	  if (audio.readyState > 1) {
	    $('#duration%id%').addClass('showDuration');
	  }
	},1000);
});

%[if %("%id=pauseon_outsideclick%" == "true")% ]%
// Pause the Playlister stack by clicking anywhere outside of itself
$(document).mouseup(function (e) {
    var container = $("#playlisterWrapper%id%");

    if (!container.is(e.target) // if the target of the click isn't the container...
            && container.has(e.target).length === 0) // ... nor a descendant of the container
	{
        $("#myaudioplayer%id%")[0].pause();
        $('#play%id%').removeClass('button-hidden');
        $('#pause%id%').removeClass('button-visible');
    }
});
%[endif]%


// If a touch device is detected, add a class to the page
$(document).ready(function () {
	if( /Android|webOS|iPhone|iPad|iPod|BlackBerry/i.test(navigator.userAgent) ) {
		$('body').addClass('playLister-touch-device-detected');
	}
});

// /*! modernizr 3.1.0 (Custom Build) | MIT *
//  * https://modernizr.com/download/?-adownload-audio !*/
!function(e,n,a){function o(e,n){return typeof e===n}function s(){var e,n,a,s,t,i,r;for(var u in c)if(c.hasOwnProperty(u)){if(e=[],n=c[u],n.name&&(e.push(n.name.toLowerCase()),n.options&&n.options.aliases&&n.options.aliases.length))for(a=0;a<n.options.aliases.length;a++)e.push(n.options.aliases[a].toLowerCase());for(s=o(n.fn,"function")?n.fn():n.fn,t=0;t<e.length;t++)i=e[t],r=i.split("."),1===r.length?Modernizr[r[0]]=s:(!Modernizr[r[0]]||Modernizr[r[0]]instanceof Boolean||(Modernizr[r[0]]=new Boolean(Modernizr[r[0]])),Modernizr[r[0]][r[1]]=s),l.push((s?"":"no-")+r.join("-"))}}function t(e){var n=u.className,a=Modernizr._config.classPrefix||"";if(p&&(n=n.baseVal),Modernizr._config.enableJSClass){var o=new RegExp("(^|\\s)"+a+"no-js(\\s|$)");n=n.replace(o,"$1"+a+"js$2")}Modernizr._config.enableClasses&&(n+=" "+a+e.join(" "+a),p?u.className.baseVal=n:u.className=n)}function i(){return"function"!=typeof n.createElement?n.createElement(arguments[0]):p?n.createElementNS.call(n,"http://www.w3.org/2000/svg",arguments[0]):n.createElement.apply(n,arguments)}var l=[],c=[],r={_version:"3.1.0",_config:{classPrefix:"",enableClasses:!0,enableJSClass:!0,usePrefixes:!0},_q:[],on:function(e,n){var a=this;setTimeout(function(){n(a[e])},0)},addTest:function(e,n,a){c.push({name:e,fn:n,options:a})},addAsyncTest:function(e){c.push({name:null,fn:e})}},Modernizr=function(){};Modernizr.prototype=r,Modernizr=new Modernizr;var u=n.documentElement,p="svg"===u.nodeName.toLowerCase();Modernizr.addTest("audio",function(){var e=i("audio"),n=!1;try{(n=!!e.canPlayType)&&(n=new Boolean(n),n.ogg=e.canPlayType('audio/ogg; codecs="vorbis"').replace(/^no$/,""),n.mp3=e.canPlayType("audio/mpeg;").replace(/^no$/,""),n.opus=e.canPlayType('audio/ogg; codecs="opus"').replace(/^no$/,""),n.wav=e.canPlayType('audio/wav; codecs="1"').replace(/^no$/,""),n.m4a=(e.canPlayType("audio/x-m4a;")||e.canPlayType("audio/aac;")).replace(/^no$/,""))}catch(a){}return n}),Modernizr.addTest("adownload",!e.externalHost&&"download"in i("a")),s(),t(l),delete r.addTest,delete r.addAsyncTest;for(var f=0;f<Modernizr._q.length;f++)Modernizr._q[f]();e.Modernizr=Modernizr}(window,document);


%[if %("%id=shuffle%" == "block")% ]%
// Shuffle button
$(function() {
	$('#shuffle%id%').click(function() {
		$("#playlisterPlaylist%id%").shuffleTracks("li:visible");
	});
});

(function($) {
	$.fn.shuffleTracks = function(childElem) {
		return this.each(function() {
			var $this = $(this);
			var shuffledElements = $this.children(childElem);
			shuffledElements.sort(function() { return (Math.round(Math.random())-0.5); });
			$this.remove(childElem);
			for(var i=0; i < shuffledElements.length; i++)
			$this.append(shuffledElements[i]);
		});
	}
})(jQuery);
%[endif]%

%[if %("%id=randomise_playlist%" == "true")% ]%
// Randomise the playlist order on page load
$(document).ready(function() {
    $("#playlisterPlaylist%id%").shuffleTracks("li:visible");
});

(function($) {
	$.fn.shuffleTracks = function(childElem) {
		return this.each(function() {
			var $this = $(this);
			var shuffledElements = $this.children(childElem);
			shuffledElements.sort(function() { return (Math.round(Math.random())-0.5); });
			$this.remove(childElem);
			for(var i=0; i < shuffledElements.length; i++)
			$this.append(shuffledElements[i]);
		});
	}
})(jQuery);
%[endif]%

// Filter functions
$(document).ready(function () {

	$('#searchButton%id%').on("click", function(e) {
		$('#noResults%id%').fadeOut(0);
		var words = $('#search%id%').val().toLowerCase().match(/\S+/g);
		if (!words) {
				$('#playlisterPlaylist%id% li').show();
		} else {
			$('#playlisterPlaylist%id% li').each(function() {
					var text = $(this).text().toLowerCase();
					var show = words.some(function(word) {
							return ~text.indexOf(word);
					});
					$(this).toggle(show);
			});
		}

		// Open the playlist, if it has been toggled closed
		$("#playlisterPlaylist%id%").slideDown(300);

		// When the filter is applied, look to see if any audio is playing already
		var currentPlayingAudio = $("#myaudioplayer%id%").get(0);
    if ( currentPlayingAudio.paused ) {
				// No audio playing, so make the first playlist item active and ready to play
				$('#playlisterPlaylist%id% li').removeClass('active-playlistitem');
				$('#playlisterPlaylist%id%').find('li:visible:first').addClass('active-playlistitem');
				$('.active-playlistitem').trigger("click");
				$("#myaudioplayer%id%")[0].pause();
				$('#playlister%id%').removeClass('playlisterIsPlaying');
    } else {
        // Something is already playing, so do nothing
    }
	});

	// Search function on return button (always enabled)
	$('#search%id%').keydown(function(e){
		if(event.keyCode==13){
			$('#noResults%id%').fadeOut(0);
			var words = $('#search%id%').val().toLowerCase().match(/\S+/g);
			if (!words) {
					$('#playlisterPlaylist%id% li').show();
			} else {
				$('#playlisterPlaylist%id% li').each(function() {
						var text = $(this).text().toLowerCase();
						var show = words.some(function(word) {
								return ~text.indexOf(word);
						});
						$(this).toggle(show);
				});
			}

			// Open the playlist, if it has been toggled closed
			$("#playlisterPlaylist%id%").slideDown(300);

			var currentPlayingAudio = $("#myaudioplayer%id%").get(0);
	    if ( currentPlayingAudio.paused ) {
					// No audio playing, so make the first playlist item active and ready to play
					$('#playlisterPlaylist%id% li').removeClass('active-playlistitem');
					$('#playlisterPlaylist%id%').find('li:visible:first').addClass('active-playlistitem');
					$('.active-playlistitem').trigger("click");
					$("#myaudioplayer%id%")[0].pause();
					$('#playlister%id%').removeClass('playlisterIsPlaying');
	    } else {
	        // Something is already playing, so do nothing
	    }
		}
	});

	// No results message
	// Button press
	$('#searchButton%id%').on("click", function(e) {
		if($('#playlisterPlaylist%id%').children(':visible').length == 0) {
			$('#noResults%id%').fadeIn(0);
		}
	});
	// Return key
	$('#search%id%').keydown(function(event){
		if(event.keyCode==13){
			if($('#playlisterPlaylist%id%').children(':visible').length == 0) {
				$('#noResults%id%').fadeIn(0);
			}
		}
	});

	// Form reset button
	$('#filterResetButton%id%').click(function(){
		$('#search%id%').val('');
		$('#playlisterPlaylist%id% li').show();
		$('#noResults%id%').fadeOut(0);
	});
});
